main:
  call InitSensors(0,0,0,0) 
  gosub InitAnimateSay
  Expr = "This shows how to make the robot say what you want"      
  call Say(Expr,45)  
end

sub InitSensors(a,b,c,d)                     
    // The Utility MUST reside in the same directory as
  // the application unless you set up paths 
  print "Initializing..."
  SetCBtext("stop") // stop utility if running
  filerename ("RBsTurn.txt","SensorsTurn.txt")
  delay 100
  Spawn ("RBsensorUtility.exe","",P_NOWAIT) 
  // provide time for Utility to spawn
  delay 1000 
  ClearScr   
  //  The above code can be eliminated if you always
  //  start the Utility manually. We have code in
  //  the utility that SHOULD prevent a second copy
  //  from running - but for some unknown reason it
  //  is not 100% reliable.  The above code seems to
  //  always work on our machine.
  dim Sensors[28] //max available from utility
  dim Offsets[4]                 
  for i=0 to 27
    Sensors[i]=""
  next
  // allow setting certain angles to zero
  Offsets[0]=a
  Offsets[1]=b
  Offsets[2]=c
  Offsets[3]=d 
  // Note: This line was added to the initialization
  // It fixes timing on FIRST use  
  Call Say("",0) // Corrects animation timing on first use
return

sub Say(s,t)
  setcbtext("Say,"+s) // tell the Interface program what to read
   // now trigger  utility  to perform 
   filerename ("RBsTurn.txt","SensorsTurn.txt")
   // produce animation if requested
   if t then call AnimateSpeech(s,t)     // 55
   // continue waiting to ensure utility has finished
   while !fileexists("RBsTurn.txt") 
   wend
return

sub AnimateSpeech(s,pause)
  answer=0
  LineWidth 20
  s=Lower(s)+" *"
  _SpeechDelay=pause
  mfromstring words,s," "
  for i=0 to _MaxWords-1
    State=""
    if words[i]="*" then break
    // animate next word
    for j=1 to Length(words[i])
      L=SubString(words[i],j,1)
      call IsVowel(L,answer)
      if (answer and (State="C"))  or ((!answer) and (State="V")) or (State="")
        if answer
          if L="o"
            gosub Osound
          elseif !((L="e") and (Length(words[i])=j))
            gosub Vsound
          endif
          State="V"
        else
          gosub Constant
          State="C"
        endif
      endif
    next
  next
  gosub Smile
return

InitAnimateSay:
  SpeechDelay=0
  MaxWords=20
  Dim words[MaxWords]
  VowelState=false
  // draw nose
  LineWidth 1
   arc 360,320,440,340,2.9,3.65,3,darkgray
  line 372,323,390,260,3,darkgray
  line 425,322,410,260,3,darkgray
  //cheeks
  arc 200,330,350,200,4.5,1.3,2,gray
  arc 600,330,450,200,3.6,1.3,2,gray
  // brows
  line 240,180,300,170,5
  lineto 350,175,5
  line 560,180,500,170,5
  lineto 450,175,5
  gosub EyesNorm
  gosub Smile
return

EyesNorm:
  LineWidth 15
  circle 250,200,350,250
  circle 450,200,550,250
  LineWidth 5
  er=20
  circle 300-er,225-er,300+er,225+er,blue,lightblue
  circle 500-er,225-er,500+er,225+er,blue,lightblue
  er=10
  circle 300-er,225-er,300+er,225+er,black,black   
  circle 500-er,225-er,500+er,225+er,black,black     
  LineWidth 15
  arc 250,200,350,250
  arc 450,200,550,250
return

EyesRight:
  LineWidth 15
  circle 250,200,350,250
  circle 450,200,550,250
  LineWidth 5 
  er=20
  circle 315-er,225-er,315+er,225+er,blue,lightblue
  circle 515-er,225-er,515+er,225+er,blue,lightblue 
  er=10
  circle 315-er,225-er,315+er,225+er,black,black     
  circle 515-er,225-er,515+er,225+er,black,black
  LineWidth 15
  arc 250,200,350,250
  arc 450,200,550,250
return

EyesLeft:
  LineWidth 15
  circle 250,200,350,250
  circle 450,200,550,250
  LineWidth 5
  er=20
  circle 285-er,225-er,285+er,225+er,blue,lightblue
  circle 485-er,225-er,485+er,225+er,blue,lightblue 
  er=10
  circle 285-er,225-er,285+er,225+er,black,black     
  circle 485-er,225-er,485+er,225+er,black,black  
  LineWidth 15
  arc 250,200,350,250
  arc 450,200,550,250
return

sub IsVowel(c,&answer)
  if c="a" or c="e" or c="i" or c="o" or c="u" or c="y"
    answer= true
  else
    answer= false
  endif
return

Smile:
  linewidth 20
  rectangle 290,390,510,450,White,White
  line 300,395,320,400
  lineto 480,400
  lineto 500,395
return

Normal:
  linewidth 20
  rectangle 290,390,510,450,White,White
  line 300,400,500,400
return

Frown:
  linewidth 20
  rectangle 290,390,510,450,White,White
  line 300,405,320,400
  lineto 480,400
  lineto 500,405
return

Constant:
  linewidth 10
  rectangle 290,390,510,450,White,White
  circle 300,400,500,410,black,red
  delay _SpeechDelay
return

Vsound:
  linewidth 10
  rectangle 300,390,500,440,White,White
  //circle 300,395,500,430,black,red
  arc 320,390,480,405,3.1633,3.09
  arc 320,390,480,430,3.1,3.22
  floodfill2 400,410,red
  delay 2*_SpeechDelay
return

Osound:
  linewidth 10
  rectangle 290,380,510,450,White,White
  circle 320,400,480,410,black,red
  delay _SpeechDelay/2
  rectangle 290,380,510,450,White,White
  circle 350,395,450,420,black,red
  delay _SpeechDelay*2
  rectangle 290,380,510,450,White,White
  circle 320,400,480,410,black,red
  delay _SpeechDelay/2
return


